function [fp, d_fp] = kimball_pt_fixedpoint(pj,pi, veps, b, num_firms)

     
    
     exp_pi = exp(pi); 
     price_disp_mat = (1 - veps*(pi-repmat(pj,1,num_firms))); 
     price_disp_mat1 = price_disp_mat.^(b/veps); 
     price_disp_mat2 = price_disp_mat.^(b/veps -1); 
     
     price_disp_mat1(price_disp_mat <= 0) = 0; 
     price_disp_mat2(price_disp_mat <= 0) = 0; 
     
     fp =  log( mean( exp_pi.*price_disp_mat1,2)) - pj;
     
     d_fp = diag(b*mean( exp_pi.*price_disp_mat2,2)./mean( exp_pi.*price_disp_mat1,2) -1); 
     
end