
function p_new = fixed_point_fast(ff,p0) 

p_new = p0;

dx = 1;
counter = 0;
restart = 0;
cons = 1;
while abs(dx) > 1e-7
    if counter > 20
        p0 = mean([p0, p_new]);
        counter = 0;
        restart = restart + 1;
        cons = cons/2;
        if restart > 3
            %error(' Newton method is cycling');
            break
        end
    else
        p0 = p_new;
    end
    [ obj_fun, dobj_fun ] = ff(p0);
    dx    = cons*obj_fun/dobj_fun;
    p_new = p0 - dx;
    counter = counter + 1;
    
end


end