
function bs_y_irf = mp_irf( yjt, yjt0, burn_in, irf_periods,b,eps_s)


yjt = yjt - yjt0;    %%%% Looking at difference between models with and without nominal shocks

burn = burn_in + 2;
end_period = length(yjt);

bs_y_irf = NaN( irf_periods, 1); 

%%%
for t = 0:irf_periods
    

    [beta_coef,bint,~,~,~] = regress( yjt(burn+t:end_period), [ones(length(yjt(burn+t:end_period)),1), eps_s(burn:end_period-t)]);
    bs_y_irf(t+1) = beta_coef(2);    
    
    
end


bs_y_irf = bs_y_irf/b; 
